VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "HmacSha256 Demo"
   ClientHeight    =   5880
   ClientLeft      =   120
   ClientTop       =   420
   ClientWidth     =   9210
   BeginProperty Font 
      Name            =   "Tahoma"
      Size            =   9
      Charset         =   0
      Weight          =   400
      Underline       =   0   'False
      Italic          =   0   'False
      Strikethrough   =   0   'False
   EndProperty
   LinkTopic       =   "Form1"
   ScaleHeight     =   5880
   ScaleWidth      =   9210
   StartUpPosition =   2  'CenterScreen
   Begin VB.TextBox txtLog 
      BeginProperty Font 
         Name            =   "Courier New"
         Size            =   9
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   5115
      Left            =   60
      Locked          =   -1  'True
      MultiLine       =   -1  'True
      ScrollBars      =   3  'Both
      TabIndex        =   3
      TabStop         =   0   'False
      Top             =   720
      Width           =   9075
   End
   Begin VB.CommandButton cmdTest 
      Caption         =   "Test"
      Height          =   495
      Left            =   6420
      TabIndex        =   2
      Top             =   60
      Width           =   915
   End
   Begin VB.ComboBox cboCase 
      Height          =   345
      Left            =   1020
      Style           =   2  'Dropdown List
      TabIndex        =   1
      Top             =   135
      Width           =   5295
   End
   Begin VB.Label Label1 
      Caption         =   "Test case"
      Height          =   255
      Left            =   120
      TabIndex        =   0
      Top             =   180
      Width           =   855
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
'HMAC-SHA-512 Test vectors from RFC 4231:
'
'     Identifiers and Test Vectors for HMAC-SHA-224, HMAC-SHA-256,
'                     HMAC-SHA-384, and HMAC-SHA-512

Private Const TEST_KEYS As String = _
        "0b0b0b0b0b0b0b0b0b0b0b0b0b0b0b0b" & "0b0b0b0b|" _
      & "4a656665|" _
      & "aaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaa" & "aaaaaaaa|" _
      & "0102030405060708090a0b0c0d0e0f10" & "111213141516171819|" _
      & "0c0c0c0c0c0c0c0c0c0c0c0c0c0c0c0c" & "0c0c0c0c|" _
      & "aaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaa" & "aaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaa" _
      & "aaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaa" & "aaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaa" _
      & "aaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaa" & "aaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaa" _
      & "aaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaa" & "aaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaa" _
      & "aaaaaa|" _
      & "aaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaa" & "aaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaa" _
      & "aaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaa" & "aaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaa" _
      & "aaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaa" & "aaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaa" _
      & "aaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaa" & "aaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaa" _
      & "aaaaaa"
Private Const TEST_DATA As String = _
        "4869205468657265|" _
      & "7768617420646f2079612077616e7420" & "666f72206e6f7468696e673f|" _
      & "dddddddddddddddddddddddddddddddd" & "dddddddddddddddddddddddddddddddd" _
      & "dddddddddddddddddddddddddddddddd" & "dddd|" _
      & "cdcdcdcdcdcdcdcdcdcdcdcdcdcdcdcd" & "cdcdcdcdcdcdcdcdcdcdcdcdcdcdcdcd" _
      & "cdcdcdcdcdcdcdcdcdcdcdcdcdcdcdcd" & "cdcd|" _
      & "546573742057697468205472756e6361" & "74696f6e|" _
      & "54657374205573696e67204c61726765" & "72205468616e20426c6f636b2d53697a" _
      & "65204b6579202d2048617368204b6579" & "204669727374|" _
      & "54686973206973206120746573742075" & "73696e672061206c6172676572207468" _
      & "616e20626c6f636b2d73697a65206b65" & "7920616e642061206c61726765722074" _
      & "68616e20626c6f636b2d73697a652064" & "6174612e20546865206b6579206e6565" _
      & "647320746f2062652068617368656420" & "6265666f7265206265696e6720757365" _
      & "642062792074686520484d414320616c" & "676f726974686d2e"
Private Const TEST_EXPECTED As String = _
        "87aa7cdea5ef619d4ff0b4241a1d6cb0" & "2379f4e2ce4ec2787ad0b30545e17cde" _
      & "daa833b7d6b8a702038b274eaea3f4e4" & "be9d914eeb61f1702e696c203a126854|" _
      & "164b7a7bfcf819e2e395fbe73b56e0a3" & "87bd64222e831fd610270cd7ea250554" _
      & "9758bf75c05a994a6d034f65f8f0e6fd" & "caeab1a34d4a6b4b636e070a38bce737|" _
      & "fa73b0089d56a284efb0f0756c890be9" & "b1b5dbdd8ee81a3655f83e33b2279d39" _
      & "bf3e848279a722c806b485a47e67c807" & "b946a337bee8942674278859e13292fb|" _
      & "b0ba465637458c6990e5a8c5f61d4af7" & "e576d97ff94b872de76f8050361ee3db" _
      & "a91ca5c11aa25eb4d679275cc5788063" & "a5f19741120c4f2de2adebeb10a298dd|" _
      & "415fad6271580a531d4179bc891d87a6|" _
      & "80b24263c7c1a3ebb71493c1dd7be8b4" & "9b46d1f41b4aeec1121b013783f8f352" _
      & "6b56d037e05f2598bd0fd2215d6a1e52" & "95e64f73f63f0aec8b915a985d786598|" _
      & "e37b6a775dc87dbaa4dfa9f96e5e3ffd" & "debd71f8867289865df5a32d20cdc944" _
      & "b6022cac3c4982b10d5eeb55c3e4de15" & "134676fb6de0446065c97440fa8c6a58"

Private strKeys() As String
Private strData() As String
Private strExpected() As String
Private HS512 As HS512

Private Function Fold(ByVal S As String) As String
    With HS512
        S = .Encode(.Decode(S), edfHexAsciiAddr, efCrLf)
    End With
    S = vbTab & Replace$(S, vbNewLine, vbNewLine & vbTab)
    Fold = Left$(S, Len(S) - 1)
End Function

Private Sub cboCase_Click()
    With txtLog
        .Text = ""
        .SelStart = 0
    End With
    cmdTest.SetFocus
End Sub

Private Sub cmdTest_Click()
    Dim intCase As Integer
    Dim bytSig() As Byte
    
    intCase = cboCase.ListIndex '1 (one) less than RFC 4231 case numbers.
    With txtLog
        .Text = ""
        .SelStart = 0
        .SelText = cboCase.List(intCase) & vbNewLine _
                 & String$(Len(cboCase.List(intCase)), "") & vbNewLine
        .SelText = "Key:" & vbNewLine & Fold(strKeys(intCase)) & vbNewLine
        .SelText = "Data:" & vbNewLine & Fold(strData(intCase)) & vbNewLine
        With HS512
            .InitHmac .Decode(strKeys(intCase))
            bytSig = .HmacSha512(.Decode(strData(intCase)))
            If intCase = 4 Then ReDim Preserve bytSig(15) 'Truncate to 128 bits ("Case 5").
            txtLog.SelText = "HmacSha512 result:" & vbNewLine _
                           & Fold(.Encode(bytSig)) & vbNewLine
        End With
        .SelText = "Expected (RFC) result:" & vbNewLine & Fold(strExpected(intCase))
        .SelStart = 0
    End With
End Sub

Private Sub Form_Load()
    strKeys = Split(TEST_KEYS, "|")
    strData = Split(TEST_DATA, "|")
    strExpected = Split(TEST_EXPECTED, "|")
    Set HS512 = New HS512
    Show
    With cboCase
        .AddItem "Case 1"
        .AddItem "Case 2 - key shorter than the length of the HMAC output"
        .AddItem "Case 3 - combined length of key and data > 64 bytes"
        .AddItem "Case 4 - combined length of key and data > 64 bytes"
        .AddItem "Case 5 - truncation of output to 128 bits"
        .AddItem "Case 6 - key larger than 128 bytes"
        .AddItem "Case 7 - key and data that is larger than 128 bytes"
        .ListIndex = 0
    End With
End Sub

Private Sub Form_Resize()
    If WindowState <> vbMinimized Then
        If Width < 9450 Then Width = 9450
        If Height < 3690 Then Height = 3690
        With txtLog
            .Move 0, .Top, ScaleWidth, ScaleHeight - .Top
        End With
    End If
End Sub
